package com.example.afrishop_v3.controllers;

import com.example.afrishop_v3.models.Complain;
import com.example.afrishop_v3.repository.ComplainRepository;
import org.springframework.data.domain.PageRequest;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
public class ComplainController {
    private final ComplainRepository repository;

    public ComplainController(ComplainRepository repository) {
        this.repository = repository;
    }


    @PostMapping(value ="/saveComplain")
    public Complain saveProduct(@ModelAttribute("Complain") Complain complain){
        return repository.save(complain);
    }

    @GetMapping(value = "/complains")
    //@PreAuthorize("hasAuthority('ADMIN_USER') or hasAuthority('STANDARD_USER')")
    public List<Complain> getList(@RequestParam(value = "pageNo") Integer pageNo, @RequestParam(value = "pageSize") Integer pageSize) {
        return repository.findAll(PageRequest.of(pageNo, pageSize)).toList();
    }
}
