package com.example.afrishop_v3.controllers;

import com.example.afrishop_v3.base.Result;
import com.example.afrishop_v3.models.TbCfToicoupon;
import com.example.afrishop_v3.repository.TbCfCouponRepository;
import com.example.afrishop_v3.repository.TbCfToicouponRepository;
import com.example.afrishop_v3.security.services.AuthenticationUser;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.LinkedHashMap;
import java.util.List;

@RestController
@RequestMapping("/coupon")
public class CouponController {
    private final TbCfToicouponRepository repository;
    private final AuthenticationUser user;

    public CouponController(TbCfToicouponRepository repository, AuthenticationUser user) {
        this.repository = repository;
        this.user = user;
    }


    @GetMapping
    public Result getUserCoupons(){
        String userId = user.userId();
        List<TbCfToicoupon> availableCoupons = repository.queryUserAvailableCoupon(userId);
        List<TbCfToicoupon> expiredCoupons = repository.queryUserExpiredCoupon(userId);
        List<TbCfToicoupon> usedCoupons = repository.queryUserUsedCoupon(userId);

        LinkedHashMap<String, Object> hashMap = new LinkedHashMap<>();

        hashMap.put("validCouponList",availableCoupons);
        hashMap.put("usedCouponList",usedCoupons);
        hashMap.put("expiredCouponList",expiredCoupons);

        return new Result<>(hashMap);
    }
}
