package com.example.afrishop_v3.repository;

import com.example.afrishop_v3.models.TbCfStationItem;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;
import org.springframework.data.repository.query.Param;

import java.util.List;

public interface TbCfStationItemRepository extends PagingAndSortingRepository<TbCfStationItem,String> {
    Page<TbCfStationItem> findAllByItemCategorytwo(String category, Pageable pageable);
    Page<TbCfStationItem> findAllByItemDescritionId(String description, Pageable pageable);
    Page<TbCfStationItem> findAllByItemLabelContaining(String label, Pageable pageable);
    @Query(value = "select a from #{#entityName} a WHERE a.itemId <> :itemId and (a.itemDescritionId = :descriptionId or a.itemCategorytwo = :categoryTwo  or a.itemCategory = :category )")
    Page<TbCfStationItem> getRecommendItems(@Param("itemId") String itemId,@Param("descriptionId") String descriptionId,@Param("categoryTwo") String categoryTwo,@Param("category") String category, Pageable pageable);
    Page<TbCfStationItem> findAllByItemNameContainingOrItemTagsContaining(String itemName, String itemTags, Pageable pageable);
    Page<TbCfStationItem> findByItemCategory(String itemName, Pageable pageable);
    List<TbCfStationItem> findAllByItemDescritionId(String id);
}
